/* Soubor je ulozen v kodovani UTF-8.
 * Kontrola kódování: Příliš žluťoučký kůň úpěl ďábelské ódy. */




/*******************************************************************************
 * Instance třídy {@code CheckedAccount} představují ...
 *
 * @author    jméno autora
 * @version   0.00.000
 */
public class CheckedAccount extends Account implements WellInforming {
    
    private int minimalBalance;
    
    public CheckedAccount(Person owner, int minimalBalance, int initialBalance) {
        super(owner, initialBalance);
        if(initialBalance < minimalBalance) {
            throw new IllegalArgumentException("initialBalance < minimalBalance");
        }
        this.minimalBalance = minimalBalance;
    }
    
    @Override
    public boolean add(int amount) {
        if(amount + getBalance() >= getMinimalBalance()) {
            return super.add(amount);
        } else {
            return false;
        }
    }
    
    public int getMinimalBalance() {
        return minimalBalance;
    }

    @Override
    public void info() {
        System.out.println("CheckedAccount owner=" + getOwner()
            + " balance=" + getBalance());
    }

    public void writeDetailedInfo() {
        writeInfo();
        System.out.println("minimal balance="+getMinimalBalance());
    }
}
